<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: arm_compute/runtime/Lut.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_lut_8h_source.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Lut.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_lut_8h.xhtml">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2016, 2017 ARM Limited.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: MIT</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a copy</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * of this software and associated documentation files (the &quot;Software&quot;), to</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * deal in the Software without restriction, including without limitation the</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * sell copies of the Software, and to permit persons to whom the Software is</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * furnished to do so, subject to the following conditions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * The above copyright notice and this permission notice shall be included in all</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * copies or substantial portions of the Software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * SOFTWARE.</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#ifndef __ARM_COMPUTE_LUT_H__</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define __ARM_COMPUTE_LUT_H__</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_i_lut_8h.xhtml">arm_compute/core/ILut.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_types_8h.xhtml">arm_compute/core/Types.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_lut_allocator_8h.xhtml">arm_compute/runtime/LutAllocator.h</a>&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;cstddef&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;cstdint&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacearm__compute.xhtml">arm_compute</a></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;{</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">class </span>ILutAllocator;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_lut.xhtml">   39</a></span>&#160;<span class="keyword">class </span><a class="code" href="classarm__compute_1_1_lut.xhtml">Lut</a> : <span class="keyword">public</span> <a class="code" href="classarm__compute_1_1_i_lut.xhtml">ILut</a></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;{</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <a class="code" href="classarm__compute_1_1_lut.xhtml#a0f61968969758af458b1bb644445cb4d">Lut</a>();</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <a class="code" href="classarm__compute_1_1_lut.xhtml#a0f61968969758af458b1bb644445cb4d">Lut</a>(<span class="keywordtype">size_t</span> <a class="code" href="classarm__compute_1_1_lut.xhtml#a6dac829b4ddf4a5729ac090e73696958">num_elements</a>, <a class="code" href="namespacearm__compute.xhtml#ad8ed01ff3ff33333d8e19db4d2818bb6">DataType</a> data_type);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <a class="code" href="classarm__compute_1_1_i_lut_allocator.xhtml">ILutAllocator</a> *<a class="code" href="classarm__compute_1_1_lut.xhtml#a5330adc6ef4a662806ec236e2be07bbe">allocator</a>();</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="comment">// Inherited methods overridden:</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">size_t</span>   <a class="code" href="classarm__compute_1_1_lut.xhtml#a6dac829b4ddf4a5729ac090e73696958">num_elements</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    uint32_t <a class="code" href="classarm__compute_1_1_lut.xhtml#aaf3f51cd25e1651cccf04064a9888f4e">index_offset</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">size_t</span>   <a class="code" href="classarm__compute_1_1_lut.xhtml#a68f33e9afee896dc24b32093d25c6766">size_in_bytes</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <a class="code" href="namespacearm__compute.xhtml#ad8ed01ff3ff33333d8e19db4d2818bb6">DataType</a> <a class="code" href="classarm__compute_1_1_lut.xhtml#a6dc9c052a2732f899adccfaeee468364">type</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    uint8_t *<a class="code" href="classarm__compute_1_1_lut.xhtml#ace7b855e3c647d29cc37a1ce147901dc">buffer</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordtype">void</span>     <a class="code" href="classarm__compute_1_1_lut.xhtml#aee7cb2065b88d21ac4ad05bc997ecf82">clear</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <a class="code" href="classarm__compute_1_1_lut_allocator.xhtml">LutAllocator</a> _allocator; </div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;};</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;}</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* __ARM_COMPUTE_LUT_H__ */</span><span class="preprocessor"></span></div><div class="ttc" id="classarm__compute_1_1_lut_xhtml_a5330adc6ef4a662806ec236e2be07bbe"><div class="ttname"><a href="classarm__compute_1_1_lut.xhtml#a5330adc6ef4a662806ec236e2be07bbe">arm_compute::Lut::allocator</a></div><div class="ttdeci">ILutAllocator * allocator()</div><div class="ttdoc">Return a pointer to the lut&amp;#39;s allocator. </div></div>
<div class="ttc" id="classarm__compute_1_1_lut_xhtml_a68f33e9afee896dc24b32093d25c6766"><div class="ttname"><a href="classarm__compute_1_1_lut.xhtml#a68f33e9afee896dc24b32093d25c6766">arm_compute::Lut::size_in_bytes</a></div><div class="ttdeci">size_t size_in_bytes() const override</div><div class="ttdoc">Returns the total size in bytes of the LUT. </div></div>
<div class="ttc" id="_types_8h_xhtml"><div class="ttname"><a href="_types_8h.xhtml">Types.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_lut_xhtml_aaf3f51cd25e1651cccf04064a9888f4e"><div class="ttname"><a href="classarm__compute_1_1_lut.xhtml#aaf3f51cd25e1651cccf04064a9888f4e">arm_compute::Lut::index_offset</a></div><div class="ttdeci">uint32_t index_offset() const override</div><div class="ttdoc">Indicates the offset that needs to be applied to the raw index before performing a lookup in the LUT...</div></div>
<div class="ttc" id="_lut_allocator_8h_xhtml"><div class="ttname"><a href="_lut_allocator_8h.xhtml">LutAllocator.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_lut_xhtml_a6dc9c052a2732f899adccfaeee468364"><div class="ttname"><a href="classarm__compute_1_1_lut.xhtml#a6dc9c052a2732f899adccfaeee468364">arm_compute::Lut::type</a></div><div class="ttdeci">DataType type() const override</div><div class="ttdoc">Returns the type of the LUT. </div></div>
<div class="ttc" id="classarm__compute_1_1_i_lut_allocator_xhtml"><div class="ttname"><a href="classarm__compute_1_1_i_lut_allocator.xhtml">arm_compute::ILutAllocator</a></div><div class="ttdoc">Basic interface to allocate LUTs&amp;#39;. </div><div class="ttdef"><b>Definition:</b> <a href="_i_lut_allocator_8h_source.xhtml#l00035">ILutAllocator.h:35</a></div></div>
<div class="ttc" id="classarm__compute_1_1_lut_xhtml"><div class="ttname"><a href="classarm__compute_1_1_lut.xhtml">arm_compute::Lut</a></div><div class="ttdoc">Basic implementation of the LUT interface. </div><div class="ttdef"><b>Definition:</b> <a href="_lut_8h_source.xhtml#l00039">Lut.h:39</a></div></div>
<div class="ttc" id="namespacearm__compute_xhtml"><div class="ttname"><a href="namespacearm__compute.xhtml">arm_compute</a></div><div class="ttdef"><b>Definition:</b> <a href="arm__compute_8dox_source.xhtml#l00001">arm_compute.dox:1</a></div></div>
<div class="ttc" id="classarm__compute_1_1_lut_allocator_xhtml"><div class="ttname"><a href="classarm__compute_1_1_lut_allocator.xhtml">arm_compute::LutAllocator</a></div><div class="ttdoc">Basic implementation of a CPU memory LUT allocator. </div><div class="ttdef"><b>Definition:</b> <a href="_lut_allocator_8h_source.xhtml#l00035">LutAllocator.h:35</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_lut_xhtml"><div class="ttname"><a href="classarm__compute_1_1_i_lut.xhtml">arm_compute::ILut</a></div><div class="ttdoc">Lookup Table object interface. </div><div class="ttdef"><b>Definition:</b> <a href="_i_lut_8h_source.xhtml#l00034">ILut.h:34</a></div></div>
<div class="ttc" id="classarm__compute_1_1_lut_xhtml_a0f61968969758af458b1bb644445cb4d"><div class="ttname"><a href="classarm__compute_1_1_lut.xhtml#a0f61968969758af458b1bb644445cb4d">arm_compute::Lut::Lut</a></div><div class="ttdeci">Lut()</div><div class="ttdoc">Constructor. </div></div>
<div class="ttc" id="_i_lut_8h_xhtml"><div class="ttname"><a href="_i_lut_8h.xhtml">ILut.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_lut_xhtml_a6dac829b4ddf4a5729ac090e73696958"><div class="ttname"><a href="classarm__compute_1_1_lut.xhtml#a6dac829b4ddf4a5729ac090e73696958">arm_compute::Lut::num_elements</a></div><div class="ttdeci">size_t num_elements() const override</div><div class="ttdoc">Returns the total number of elements in the LUT. </div></div>
<div class="ttc" id="classarm__compute_1_1_lut_xhtml_ace7b855e3c647d29cc37a1ce147901dc"><div class="ttname"><a href="classarm__compute_1_1_lut.xhtml#ace7b855e3c647d29cc37a1ce147901dc">arm_compute::Lut::buffer</a></div><div class="ttdeci">uint8_t * buffer() const override</div><div class="ttdoc">Returns a pointer to the start of the LUT. </div></div>
<div class="ttc" id="namespacearm__compute_xhtml_ad8ed01ff3ff33333d8e19db4d2818bb6"><div class="ttname"><a href="namespacearm__compute.xhtml#ad8ed01ff3ff33333d8e19db4d2818bb6">arm_compute::DataType</a></div><div class="ttdeci">DataType</div><div class="ttdoc">Available data types. </div><div class="ttdef"><b>Definition:</b> <a href="_types_8h_source.xhtml#l00059">Types.h:59</a></div></div>
<div class="ttc" id="classarm__compute_1_1_lut_xhtml_aee7cb2065b88d21ac4ad05bc997ecf82"><div class="ttname"><a href="classarm__compute_1_1_lut.xhtml#aee7cb2065b88d21ac4ad05bc997ecf82">arm_compute::Lut::clear</a></div><div class="ttdeci">void clear() override</div><div class="ttdoc">Clears the LUT by setting every element to zero. </div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_214608ef36d61442cb2b0c1c4e9a7def.xhtml">arm_compute</a></li><li class="navelem"><a class="el" href="dir_8bc26130589aa16388b5a02f17abf2c2.xhtml">runtime</a></li><li class="navelem"><a class="el" href="_lut_8h.xhtml">Lut.h</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
